//+------------------------------------------------------------------+
//|                                            Moving Average EA.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

#property copyright "Copyright  2010, Matrixebiz"
#property link      "matrixebiz@gmail.com"

extern int     MagicNumber = 47656;
extern bool    AlertOnly = true;
extern bool    UseStopLoss = false;
extern int     StopLoss = 66;
extern bool    UseTakeProfit = false;
extern int     TakeProfit = 66;
extern bool    close_all_at_profit$ = true;
extern double  profit$ = 2;
extern bool    close_all_at_loss$ = true;
extern double  loss$= -5;
extern double  Lots = 0.10;
extern int     TimeFrame = 0;
extern int     SignalTriggerBar = 0;

bool Only_One_Order_Per_Candle = true;
bool OrderClosed_noNEW_Same_Candle = true;
bool DecideToOpenTrade;

//+------------------------------------------------------------------+
//|                        S T A R T                                 |
//+------------------------------------------------------------------+
int start()
  {
   if(close_all_at_profit$&&AccountProfit()>=profit$){close();}
   if(close_all_at_loss$&&AccountProfit()<=loss$){close();}
   DecideToOpenTrade = true;
   string Message="";
double SMAc=iMA(NULL,TimeFrame,20,0,MODE_SMA,PRICE_CLOSE,SignalTriggerBar);
double EMAc=iMA(NULL,TimeFrame,5,0,MODE_EMA,PRICE_CLOSE,SignalTriggerBar);

double SMAp=iMA(NULL,TimeFrame,20,0,MODE_SMA,PRICE_CLOSE,SignalTriggerBar+1);
double EMAp=iMA(NULL,TimeFrame,5,0,MODE_EMA,PRICE_CLOSE,SignalTriggerBar+1);
//-------------------------------------+
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
//-------------------------------------+
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
//-------------------------------------+
     if(AccountFreeMargin()<(10*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
  
  DesideToOpen();
      if(EMAc > SMAc && EMAp < SMAp && DecideToOpenTrade){orderb();}
      if(EMAc < SMAc && EMAp > SMAp && DecideToOpenTrade){orders();}
      
         return(0); 
 
      
  }
void orderb()
{
  double StopLossLevel, TakeProfitLevel;
         if (UseStopLoss) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;
   if (AlertOnly){
         Alert("Signal Alert: ",Symbol()," Buy" );
         Sleep((Period()*60)*1000);}
if (DecideToOpenTrade && !AlertOnly) {OrderSend(Symbol(),OP_BUY, Lots, Ask, 6, StopLossLevel, TakeProfitLevel,"MA Buy", MagicNumber, 0, Blue);}

return;
}
void orders()
{
  double StopLossLevel, TakeProfitLevel;
         if (UseStopLoss) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;
   if (AlertOnly){
         Alert("Signal Alert: ",Symbol()," Sell" );
         Sleep((Period()*60)*1000);}
if (DecideToOpenTrade && !AlertOnly) {OrderSend(Symbol(),OP_SELL, Lots, Bid, 6, StopLossLevel, TakeProfitLevel,"MA Sell", MagicNumber, 0, Red);}

return;
}     

void DesideToOpen()
{
//    string AddChar = StringSubstr(Symbol(), 6, StringLen(Symbol()) - 6);
   int total = OrdersTotal();
   if (total > 0)
   {
      for(int cnt=0;cnt<total;cnt++)
      {
         if(OrderSelect(cnt,SELECT_BY_POS))
         {
            if(OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol()) DecideToOpenTrade = false;
            
         }
      }
   }
if(Only_One_Order_Per_Candle){
   // in case trades has already opened and closed within the candle
   int histotal = OrdersHistoryTotal();
   if (histotal > 0)
   {
      for(cnt=0;cnt<histotal;cnt++)
      {
         if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY))
         {
            // don't open a new position if we're still on the same OrderOpened candle
            if(OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderOpenTime() >= Time[0]) DecideToOpenTrade = false;
if(OrderClosed_noNEW_Same_Candle){
            // don't open a new position if we're still on the same OrderClosed candle
            if(OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderCloseTime() >= Time[0]) DecideToOpenTrade = false;
         
         
         }}
      }
   }
}} //
void close()
{
int totalorders = OrdersTotal();
for(int i=totalorders-1;i>=0;i--)
{
OrderSelect(i, SELECT_BY_POS);
{
if (OrderType() == OP_BUY ) 
{OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 100, Blue );
}  
        
if (OrderType() == OP_SELL ) 
{OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 100, Red );
}}}
return;
}////